//+------------------------------------------------------------------+
//|                                                       cs2011.mq5 |
//|                                         Copyright c 2011, Xupypr |
//|                               Translated to mq4 by Zhiqiang Bian |
//+------------------------------------------------------------------+
#property copyright "Copyright c 2011, Xupypr"
//+-----------------------------------+
extern double Risk=3; // Initial lot
extern int TP=2200;
extern int SL=0;
extern int Fast=30;
extern int Slow=500;
extern int Sign=36;
extern int Magic=19237498;
//+-----------------------------------+
double Money,Deposit=5000;
int start()
  {
   static bool UpSignal,DnSignal;
   if(TradeSignalCounter(UpSignal,DnSignal)) TradePerformer(UpSignal,DnSignal);
  }
//+-----------------------------------+
bool TradeSignalCounter(bool &UpSignal,bool &DnSignal)
  {
   if(Bars<100) return(false);
   if(IsNewBar())
     {
      
      DnSignal=false;
      UpSignal=false;
      
      double main=iMACD(NULL,0,Fast,Slow,Sign,PRICE_CLOSE, MODE_MAIN, 0);
      double main1=iMACD(NULL,0,Fast,Slow,Sign,PRICE_CLOSE, MODE_MAIN, 1);
      double signal=iMACD(NULL,0,Fast,Slow,Sign,PRICE_CLOSE, MODE_SIGNAL, 0);
      double signal1=iMACD(NULL,0,Fast,Slow,Sign,PRICE_CLOSE, MODE_SIGNAL, 1);
      double signal2=iMACD(NULL,0,Fast,Slow,Sign,PRICE_CLOSE, MODE_SIGNAL, 2);
      if(main>0 && main1<0) DnSignal=true;
      if(main<0 && main1>0) UpSignal=true;
      if(main1<0 && signal<signal1 && signal1>signal2) DnSignal=true;
      if(main1>0 && signal>signal1 && signal1<signal2) UpSignal=true;
      if(UpSignal||DnSignal)Comment(UpSignal, DnSignal);
      return(true);
     }
   return(false);
  }
//+-----------------------------------+
bool TradePerformer(bool &UpSignal,bool &DnSignal)
  {
   if(UpSignal)
     {
      if(PositionOpen(OP_BUY)) UpSignal=false;
     }
   if(DnSignal)
     {
      if(PositionOpen(OP_SELL)) DnSignal=false;
     }
   return(true);
  }
//+-----------------------------------+
double Money_M()
  {
   
   int total=OrdersTotal();
   double profit=0;
   for(int i=0;i<total;i++)
     {
     OrderSelect(i, SELECT_BY_POS);
      int deal_ticket=OrderTicket();
      if(OrderSymbol()!=Symbol()) continue;
      if(OrderType()!=OP_BUY && OrderType()!=OP_SELL) continue;
      profit+=OrderProfit();
      profit+=OrderSwap();
     }
   Money=Deposit+profit;
   double Min=MarketInfo(Symbol(), MODE_MINLOT);
   double Limit=MarketInfo(Symbol(), MODE_MAXLOT);
   double Lots=Risk*Money/Deposit;
   Lots=MathMin(Limit,MathMax(Min,Lots));
   return(Lots);
  }
//+-----------------------------------+
bool PositionOpen(int Type)
  {
   double volume=Money_M();
   double takeprofit=0,stoploss=0;
   double volumepos=PositionGetVolume();
   if(Type==OP_BUY) 
   {  
      if(volumepos>=0)
         volume-=volumepos;
      else
         closeAll(OP_SELL, Magic);
   }
   else
   {
      if(volumepos<=0)
         volume+=volumepos;
      else
         closeAll(OP_BUY, Magic);
   }
   volume=NormalizeDouble(volume,2);
   int type;
   double price;
   if(volume<=0) return(false);
   if(Type==OP_SELL)
     {
      type=OP_SELL;
      price=Bid;
      if(TP!=0) takeprofit = price-TP*Point;
      if(SL!=0) stoploss = price+SL*Point;
     }
   if(Type==OP_BUY)
     {
      type=OP_BUY;
      price=Ask;
      if(TP!=0) takeprofit = price+TP*Point;
      if(SL!=0) stoploss = price-SL*Point;
     }
   volume = MathMin(volume,MarketInfo(Symbol(),MODE_MAXLOT));
   double sl = stoploss;
   double tp = takeprofit;
   int deviation=MarketInfo(Symbol(), MODE_SPREAD);
   string comment=DoubleToStr(Money,2)+"$";
   xOrderSend(Symbol(),type,volume,price,deviation,sl,tp,comment, Magic,0);
   return(true);
  }
//+-----------------------------------+
bool IsNewBar()
  {
   static datetime Told;
   if(Time[0]!=Told)
     {
      Told=Time[0];
      return(true);
     }
   return(false);
  }
  
double PositionGetVolume(){
   double lot=0;
   for(int i=0;i<OrdersTotal();i++)
   {
      OrderSelect(i, SELECT_BY_POS);
      if(OrderType()==OP_BUY)
         lot+=OrderLots();  
      else if(OrderType()==OP_SELL)
         lot-=OrderLots();      
   }
   return(lot);
}
//+-----------------------------------+

void closeAll(int cmd, int magic, double minimumProfit=-10000000)
{
   for(int k=0;k<10||OrdersTotal()==0;k++){
      for(int i=OrdersTotal()-1;i>=0;i--)
      {
         OrderSelect(i,SELECT_BY_POS);
         if(OrderMagicNumber()!=magic) continue;
         if(OrderType()==OP_BUY && cmd==OP_BUY){
            if(OrderProfit()>minimumProfit)
               OrderClose(OrderTicket(), OrderLots(), Bid, 20);
         }
         else if(OrderType()==OP_SELL&&cmd==OP_SELL)
         {
            if(OrderProfit()>minimumProfit)
               OrderClose(OrderTicket(), OrderLots(), Ask, 20);
         }
         else if(cmd==OrderType())
         {
            OrderDelete(OrderTicket());
         }
      }
   }
}

int xOrderSend(string symbol, int cmd, double volume, double price, int slippage, double stoploss, double takeprofit, 
   string comment="", int magic=0, datetime expiration=0, color arrow_color=CLR_NONE)
{
   if(0>AccountFreeMarginCheck(symbol, OP_BUY, volume)) return;
   if(0>AccountFreeMarginCheck(symbol, OP_SELL, volume)) return;
   double lot=volume;
   while(lot>5.0)
   {
      lot-=5.0;
      OrderSend(symbol, cmd, 5.0, price, slippage, stoploss, takeprofit, comment, magic, expiration, arrow_color);
   }
   return(OrderSend(symbol, cmd, lot, price, slippage, stoploss, takeprofit, comment, magic, expiration, arrow_color));
}
